/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the MicrosoftAdsStaticDtoAuthorizerAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MicrosoftAdsStaticDtoAuthorizerAllOf{}

// MicrosoftAdsStaticDtoAuthorizerAllOf struct for MicrosoftAdsStaticDtoAuthorizerAllOf
type MicrosoftAdsStaticDtoAuthorizerAllOf struct {
	Label          *string `json:"label,omitempty"`
	DeveloperToken *string `json:"developerToken,omitempty"`
	ClientId       *string `json:"clientId,omitempty"`
	ClientSecret   *string `json:"clientSecret,omitempty"`
	RedirectUri    *string `json:"redirectUri,omitempty"`
	Tenant         *string `json:"tenant,omitempty"`
}

// NewMicrosoftAdsStaticDtoAuthorizerAllOf instantiates a new MicrosoftAdsStaticDtoAuthorizerAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMicrosoftAdsStaticDtoAuthorizerAllOf() *MicrosoftAdsStaticDtoAuthorizerAllOf {
	this := MicrosoftAdsStaticDtoAuthorizerAllOf{}
	return &this
}

// NewMicrosoftAdsStaticDtoAuthorizerAllOfWithDefaults instantiates a new MicrosoftAdsStaticDtoAuthorizerAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMicrosoftAdsStaticDtoAuthorizerAllOfWithDefaults() *MicrosoftAdsStaticDtoAuthorizerAllOf {
	this := MicrosoftAdsStaticDtoAuthorizerAllOf{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetDeveloperToken returns the DeveloperToken field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) GetDeveloperToken() string {
	if o == nil || IsNil(o.DeveloperToken) {
		var ret string
		return ret
	}
	return *o.DeveloperToken
}

// GetDeveloperTokenOk returns a tuple with the DeveloperToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) GetDeveloperTokenOk() (*string, bool) {
	if o == nil || IsNil(o.DeveloperToken) {
		return nil, false
	}
	return o.DeveloperToken, true
}

// HasDeveloperToken returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) HasDeveloperToken() bool {
	if o != nil && !IsNil(o.DeveloperToken) {
		return true
	}

	return false
}

// SetDeveloperToken gets a reference to the given string and assigns it to the DeveloperToken field.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) SetDeveloperToken(v string) {
	o.DeveloperToken = &v
}

// GetClientId returns the ClientId field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) GetClientId() string {
	if o == nil || IsNil(o.ClientId) {
		var ret string
		return ret
	}
	return *o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) GetClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.ClientId) {
		return nil, false
	}
	return o.ClientId, true
}

// HasClientId returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) HasClientId() bool {
	if o != nil && !IsNil(o.ClientId) {
		return true
	}

	return false
}

// SetClientId gets a reference to the given string and assigns it to the ClientId field.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) SetClientId(v string) {
	o.ClientId = &v
}

// GetClientSecret returns the ClientSecret field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) GetClientSecret() string {
	if o == nil || IsNil(o.ClientSecret) {
		var ret string
		return ret
	}
	return *o.ClientSecret
}

// GetClientSecretOk returns a tuple with the ClientSecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) GetClientSecretOk() (*string, bool) {
	if o == nil || IsNil(o.ClientSecret) {
		return nil, false
	}
	return o.ClientSecret, true
}

// HasClientSecret returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) HasClientSecret() bool {
	if o != nil && !IsNil(o.ClientSecret) {
		return true
	}

	return false
}

// SetClientSecret gets a reference to the given string and assigns it to the ClientSecret field.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) SetClientSecret(v string) {
	o.ClientSecret = &v
}

// GetRedirectUri returns the RedirectUri field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) GetRedirectUri() string {
	if o == nil || IsNil(o.RedirectUri) {
		var ret string
		return ret
	}
	return *o.RedirectUri
}

// GetRedirectUriOk returns a tuple with the RedirectUri field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) GetRedirectUriOk() (*string, bool) {
	if o == nil || IsNil(o.RedirectUri) {
		return nil, false
	}
	return o.RedirectUri, true
}

// HasRedirectUri returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) HasRedirectUri() bool {
	if o != nil && !IsNil(o.RedirectUri) {
		return true
	}

	return false
}

// SetRedirectUri gets a reference to the given string and assigns it to the RedirectUri field.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) SetRedirectUri(v string) {
	o.RedirectUri = &v
}

// GetTenant returns the Tenant field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) GetTenant() string {
	if o == nil || IsNil(o.Tenant) {
		var ret string
		return ret
	}
	return *o.Tenant
}

// GetTenantOk returns a tuple with the Tenant field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) GetTenantOk() (*string, bool) {
	if o == nil || IsNil(o.Tenant) {
		return nil, false
	}
	return o.Tenant, true
}

// HasTenant returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) HasTenant() bool {
	if o != nil && !IsNil(o.Tenant) {
		return true
	}

	return false
}

// SetTenant gets a reference to the given string and assigns it to the Tenant field.
func (o *MicrosoftAdsStaticDtoAuthorizerAllOf) SetTenant(v string) {
	o.Tenant = &v
}

func (o MicrosoftAdsStaticDtoAuthorizerAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MicrosoftAdsStaticDtoAuthorizerAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.DeveloperToken) {
		toSerialize["developerToken"] = o.DeveloperToken
	}
	if !IsNil(o.ClientId) {
		toSerialize["clientId"] = o.ClientId
	}
	if !IsNil(o.ClientSecret) {
		toSerialize["clientSecret"] = o.ClientSecret
	}
	if !IsNil(o.RedirectUri) {
		toSerialize["redirectUri"] = o.RedirectUri
	}
	if !IsNil(o.Tenant) {
		toSerialize["tenant"] = o.Tenant
	}
	return toSerialize, nil
}

type NullableMicrosoftAdsStaticDtoAuthorizerAllOf struct {
	value *MicrosoftAdsStaticDtoAuthorizerAllOf
	isSet bool
}

func (v NullableMicrosoftAdsStaticDtoAuthorizerAllOf) Get() *MicrosoftAdsStaticDtoAuthorizerAllOf {
	return v.value
}

func (v *NullableMicrosoftAdsStaticDtoAuthorizerAllOf) Set(val *MicrosoftAdsStaticDtoAuthorizerAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableMicrosoftAdsStaticDtoAuthorizerAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableMicrosoftAdsStaticDtoAuthorizerAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMicrosoftAdsStaticDtoAuthorizerAllOf(val *MicrosoftAdsStaticDtoAuthorizerAllOf) *NullableMicrosoftAdsStaticDtoAuthorizerAllOf {
	return &NullableMicrosoftAdsStaticDtoAuthorizerAllOf{value: val, isSet: true}
}

func (v NullableMicrosoftAdsStaticDtoAuthorizerAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMicrosoftAdsStaticDtoAuthorizerAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
